#!/bin/bash

source /opt/migrate-for-gce/functions.sh

ALIAS_IP_DIR="/opt/migrate-for-gce/alias-ips"
UTIL_SCRIPTS_DIR="/etc/migrate-for-gce/alias-ips"
WICKED_SVC="/etc/wicked"
UBUNTU_NETPLAN="/etc/netplan"

DHCLIENT_SCRIPT="/etc/dhcp/dhclient.d/aliasip.sh"
if is_ubuntu_family ; then
	DHCLIENT_SCRIPT="/etc/dhcp/dhclient-exit-hooks.d/zz-aliasip"
elif is_suse ; then
   DHCLIENT_SCRIPT="/etc/sysconfig/network/if-up.d/zz-aliasip"
fi

CFG=$1
migrate_log "setup-alias-ip, mode=${CFG}"

if [ "${CFG}" == "iscsi" ] ; then
	IBFT_HWADDR=`cat /sys/firmware/ibft/ethernet0/mac`
	if [ ! -z "${IBFT_HWADDR}" ] ; then
		INTERFACE=`get_nic_by_hwaddr ${IBFT_HWADDR}`
		. $ALIAS_IP_DIR/alias-ip-functions
		rewrite_rules
		rewrite_aliases
	fi
elif [ "${CFG}" == "detach" ] ; then
 	mkdir -p $UTIL_SCRIPTS_DIR
	cp -f $ALIAS_IP_DIR/alias-ip-utils ${UTIL_SCRIPTS_DIR}/
	cp -f $ALIAS_IP_DIR/alias-ip-functions ${UTIL_SCRIPTS_DIR}/
	cp -f $ALIAS_IP_DIR/aliasip.sh ${UTIL_SCRIPTS_DIR}/
	cp -f $ALIAS_IP_DIR/aliasip.sh $DHCLIENT_SCRIPT
	if [ -d ${WICKED_SVC} ] ; then
		install_wicked_script $ALIAS_IP_DIR/wicked-aliasip.sh
	fi
	if [ -d ${UBUNTU_NETPLAN} ] ; then
		install_systemd_service $ALIAS_IP_DIR/migrate-for-gce-aliasip.service multi-user.target
	fi
	touch /etc/migrate-for-gce/actions/bypass/setup-alias-ips
	touch /etc/migrate-for-gce/actions/apply-net-changes
elif [ "${CFG}" == "origin" ] ; then
	exit 0 # Nothing to be done
else
	exit 1
fi

