
# Write directly to console to make sure our output is seen if system is not
# configured properly
console_log() {
  echo "migrate-for-gce: dracut: $*" > /dev/kmsg
}

run_and_console_log() {
  console_log "> $*"
  "$@" 2>&1 | while read -r line; do
    console_log "# $line"
  done
}

run_hook_and_log() {
  console_log "hook: $$: > $*"
  # Logging stderr too
  output=$("$@" 2>/tmp/err_$$)
  # Preserve return code
  rc=$?
  console_log "hook: $$: rc: $rc"
  err=$(cat /tmp/err_$$ 2>/dev/null)
  rm -f /tmp/err_$$
  if [ -n "${output}" ] ; then
    echo "${output}" | while read -r line; do
      console_log "$$: # $line"
    done
  fi
  if [ -n "${err}" ] ; then
    echo "${err}" | while read -r line; do
      console_log "$$: e $line"
    done
  fi
  # Return the output of the original process
  echo "${output}"
  >&2 echo "${err}"
  return $rc
}
