#!/bin/bash

. /opt/migrate-for-gce/functions.sh

initiatorname_file="/etc/iscsi/initiatorname.iscsi"
initiatorname_file_backup="/etc/iscsi/initiatorname.iscsi.pre-gce"

restart_suse_iscsid () {
  killall -w iscsid
  iscsid -c /etc/iscsid.conf
}

if [ "$1" = "revert" ] ; then
  if [ ! -f "${initiatorname_file_backup}" ] ; then
    exit 0
  fi
  migrate_log "Restoring initiator name"
  mv -f "${initiatorname_file_backup}" "${initiatorname_file}"
  exit $?
fi

if [ ! -f /sys/firmware/ibft/initiator/initiator-name ] ; then
  migrate_log "Initiator name was not specified in iBFT"
  exit 0
fi

initiatorname=$(cat /sys/firmware/ibft/initiator/initiator-name)

if grep -q "${initiatorname}" "${initiatorname_file}" ; then
  migrate_log "Initiator name already up-to-date"
  exit 0
fi

if [ ! -f "${initiatorname_file_backup}" ] ; then
  mv "${initiatorname_file}" "${initiatorname_file_backup}"
fi

migrate_log "Setting initiator name to ${initiatorname}"

echo "InitiatorName=${initiatorname}" > "${initiatorname_file}"

sync

if is_suse ; then
  # Restart iscsid in order to re-read the initiator name
  restart_suse_iscsid
fi

exit 0
