#!/bin/bash

source /opt/migrate-for-gce/functions.sh

migrate_log "Starting trim-disks"

# Run fstrim on all iSCSI-backed block devices. Might want to explore the -m option for speed ups on fragmented drives. 
#
while read mntsrc mntpnt fstype mntopts rest ; do
	blkdev=`resolve_mp_dev "$mntsrc"`
	if [ -b $blkdev ] ; then
		if is_iscsi $blkdev ; then
			migrate_log "Running fstrim on $blkdev on $mntpnt"
			fstrim -v $mntpnt
			migrate_log "Finished running on $blkdev on $mntpnt"
			sync
		fi
	fi
done < /proc/mounts