#!/bin/bash

source /opt/migrate-for-gce/functions.sh

if [ ! -f /usr/bin/vmware-uninstall-tools.pl ]; then
  migrate_log "Vmware Tools not found, skipping uninstall"
  exit 0
fi

if [ -f /etc/vmware-tools/locations ]; then
  # Avoid rebuilding the ram disk by VMWare tools un-installer
  {
    echo "remove_answer RESTORE_RAMDISK_CMD"
    echo "remove_answer RESTORE_RAMDISK_KERNELS"
    echo "remove_answer RESTORE_RAMDISK_ONECALL"
  } >> /etc/vmware-tools/locations

fi

/usr/bin/vmware-uninstall-tools.pl
exit $?
